## rustc-mozilla 1.59.0+dfsg1

=== src/test/run-make-fulldeps/core-no-fp-fmt-parse/Makefile ===
-include ../tools.mk

all:
	$(RUSTC) --edition=2018 --crate-type=rlib ../../../../library/core/src/lib.rs --cfg no_fp_fmt_parse

=== src/test/run-make-fulldeps/coverage-llvmir/Makefile ===
# needs-profiler-support

# Rust coverage maps support LLVM Coverage Mapping Format versions 5 and 6,
# corresponding with LLVM versions 12 and 13, respectively.
# When upgrading LLVM versions, consider whether to enforce a minimum LLVM
# version during testing, with an additional directive at the top of this file
# that sets, for example: `min-llvm-version: 12.0`

-include ../coverage/coverage_tools.mk

BASEDIR=../coverage-llvmir

ifeq ($(UNAME),Darwin)
	INSTR_PROF_DATA_SUFFIX=,regular,live_support
	DATA_SECTION_PREFIX=__DATA,
	LLVM_COV_SECTION_PREFIX=__LLVM_COV,
	COMDAT_IF_SUPPORTED=
else
	INSTR_PROF_DATA_SUFFIX=
	DATA_SECTION_PREFIX=
	LLVM_COV_SECTION_PREFIX=
	COMDAT_IF_SUPPORTED=, comdat
endif

DEFINE_INTERNAL=define internal

ifdef IS_WINDOWS
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK,WINDOWS \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='.lprfd$$M' \
		-DINSTR_PROF_NAME='.lprfn$$M' \
		-DINSTR_PROF_CNTS='.lprfc$$M' \
		-DINSTR_PROF_VALS='.lprfv$$M' \
		-DINSTR_PROF_VNODES='.lprfnd$$M' \
		-DINSTR_PROF_COVMAP='.lcovmap$$M' \
		-DINSTR_PROF_COVFUN='.lcovfun$$M' \
		-DINSTR_PROF_ORDERFILE='.lorderfile$$M'
else
	LLVM_FILECHECK_OPTIONS=\
		-check-prefixes=CHECK \
		-DDEFINE_INTERNAL='$(DEFINE_INTERNAL)' \
		-DCOMDAT_IF_SUPPORTED='$(COMDAT_IF_SUPPORTED)' \
		-DINSTR_PROF_DATA='$(DATA_SECTION_PREFIX)__llvm_prf_data$(INSTR_PROF_DATA_SUFFIX)' \
		-DINSTR_PROF_NAME='$(DATA_SECTION_PREFIX)__llvm_prf_names' \
		-DINSTR_PROF_CNTS='$(DATA_SECTION_PREFIX)__llvm_prf_cnts' \
		-DINSTR_PROF_VALS='$(DATA_SECTION_PREFIX)__llvm_prf_vals' \
		-DINSTR_PROF_VNODES='$(DATA_SECTION_PREFIX)__llvm_prf_vnds' \
		-DINSTR_PROF_COVMAP='$(LLVM_COV_SECTION_PREFIX)__llvm_covmap' \
		-DINSTR_PROF_COVFUN='$(LLVM_COV_SECTION_PREFIX)__llvm_covfun' \
		-DINSTR_PROF_ORDERFILE='$(DATA_SECTION_PREFIX)__llvm_orderfile'
endif

all: test_llvm_ir

test_llvm_ir:
	# Compile the test program with non-experimental coverage instrumentation, and generate LLVM IR
	$(RUSTC) $(BASEDIR)/testprog.rs \
			-Zinstrument-coverage \
			--emit=llvm-ir

	cat "$(TMPDIR)"/testprog.ll | \
			"$(LLVM_FILECHECK)" $(BASEDIR)/filecheck.testprog.txt $(LLVM_FILECHECK_OPTIONS)

=== src/test/run-make-fulldeps/coverage-reports/Makefile ===
# needs-profiler-support
# ignore-windows-gnu

# Rust coverage maps support LLVM Coverage Mapping Format versions 5 and 6,
# corresponding with LLVM versions 12 and 13, respectively.
# When upgrading LLVM versions, consider whether to enforce a minimum LLVM
# version during testing, with an additional directive at the top of this file
# that sets, for example: `min-llvm-version: 12.0`

# FIXME(mati865): MinGW GCC miscompiles compiler-rt profiling library but with Clang it works
# properly. Since we only have GCC on the CI ignore the test for now.

-include ../coverage/coverage_tools.mk

BASEDIR=../coverage-reports
SOURCEDIR=../coverage

# The `llvm-cov show` flag `--debug`, used to generate the `counters` output files, is only
# enabled if LLVM assertions are enabled. This requires Rust config `llvm/optimize` and not
# `llvm/release_debuginfo`. Note that some CI builds disable debug assertions (by setting
# `NO_LLVM_ASSERTIONS=1`), so the tests must still pass even if the `--debug` flag is
# not supported. (Note that `counters` files are only produced in the `$(TMPDIR)`
# directory, for inspection and debugging support. They are *not* copied to `expected_*`
# files when `--bless`ed.)
LLVM_COV_DEBUG := $(shell \
		"$(LLVM_BIN_DIR)"/llvm-cov show --debug 2>&1 | \
		grep -q "Unknown command line argument '--debug'"; \
		echo $$?)
ifeq ($(LLVM_COV_DEBUG), 1)
DEBUG_FLAG=--debug
endif

# FIXME(richkadel): I'm adding `--ignore-filename-regex=` line(s) for specific test(s) that produce
# `llvm-cov` results for multiple files (for example `uses_crate.rs` and `used_crate/mod.rs`) as a
# workaround for two problems causing tests to fail on Windows:
#
# 1. When multiple files appear in the `llvm-cov show` results, each file's coverage results can
#    appear in different a different order. Whether this is random or, somehow, platform-specific,
#    the Windows output flips the order of the files, compared to Linux. In the `uses_crate.rs`
#    test, the only test-unique (interesting) results we care about are the results for only one
#    of the two files, `mod/uses_crate.rs`, so the workaround is to ignore all but this one file.
#    In the future, we may want a more sophisticated solution that splits apart `llvm-cov show`
#    results into separate results files for each result (taking care not to create new file
#    paths that might be too long for Windows MAX_PATH limits when creating these new sub-results,
#    as well).
# 2. When multiple files appear in the `llvm-cov show` results, the results for each file are
#    prefixed with their filename, including platform-specific path separators (`\` for Windows,
#    and `/` everywhere else). This could be filtered or normalized of course, but by ignoring
#    coverage results for all but one of the file, the filenames are no longer included anyway.
#    If this changes (if/when we decide to support `llvm-cov show` results for multiple files),
#    the file path separator differences may need to be addressed.
#
# Since this is only a workaround, I decided to implement the override by adding an option for
# each file to be ignored, using a `--ignore-filename-regex=` entry for each one, rather than
# implement some more sophisticated solution with a new custom test directive in the test file
# itself (similar to `expect-exit-status`) because that would add a lot of complexity and still
# be a workaround, with the same result, with no benefit.
#
# Yes these `--ignore-filename-regex=` options are included in all invocations of `llvm-cov show`
# for now, but it is effectively ignored for all tests that don't include this file anyway.
#
# (Note that it's also possible the `_counters.<test>.txt` and `<test>.json` files (if generated)
# may order results from multiple files inconsistently, which might also have to be accomodated
# if and when we allow `llvm-cov` to produce results for multiple files. Note, the path separators
# appear to be normalized to `/` in those files, thankfully.)
LLVM_COV_IGNORE_FILES=\
	--ignore-filename-regex='(uses_crate.rs|uses_inline_crate.rs)'

all: $(patsubst $(SOURCEDIR)/lib/%.rs,%,$(wildcard $(SOURCEDIR)/lib/*.rs)) $(patsubst $(SOURCEDIR)/%.rs,%,$(wildcard $(SOURCEDIR)/*.rs))

# Ensure there are no `expected` results for tests that may have been removed or renamed
.PHONY: clear_expected_if_blessed
clear_expected_if_blessed:
ifdef RUSTC_BLESS_TEST
	rm -f expected_*
endif

-include clear_expected_if_blessed

%: $(SOURCEDIR)/lib/%.rs
	# Compile the test library with coverage instrumentation
	$(RUSTC) $(SOURCEDIR)/lib/$@.rs \
			$$( sed -n 's/^\/\/ compile-flags: \([^#]*\).*/\1/p' $(SOURCEDIR)/lib/$@.rs ) \
			--crate-type rlib -Zinstrument-coverage

%: $(SOURCEDIR)/%.rs
	# Compile the test program with coverage instrumentation
	$(RUSTC) $(SOURCEDIR)/$@.rs \
			$$( sed -n 's/^\/\/ compile-flags: \([^#]*\).*/\1/p' $(SOURCEDIR)/$@.rs ) \
			-L "$(TMPDIR)" -Zinstrument-coverage

	# Run it in order to generate some profiling data,
	# with `LLVM_PROFILE_FILE=<profdata_file>` environment variable set to
	# output the coverage stats for this run.
	LLVM_PROFILE_FILE="$(TMPDIR)"/$@.profraw \
			$(call RUN,$@) || \
			( \
				status=$$?; \
				grep -q "^\/\/ expect-exit-status-$$status" $(SOURCEDIR)/$@.rs || \
				( >&2 echo "program exited with an unexpected exit status: $$status"; \
					false \
				) \
			)

	# Run it through rustdoc as well to cover doctests.
	# `%p` is the pid, and `%m` the binary signature. We suspect that the pid alone
	# might result in overwritten files and failed tests, as rustdoc spawns each
	# doctest as its own process, so make sure the filename is as unique as possible.
	LLVM_PROFILE_FILE="$(TMPDIR)"/$@-%p-%m.profraw \
			$(RUSTDOC) --crate-name workaround_for_79771 --test $(SOURCEDIR)/$@.rs \
			$$( sed -n 's/^\/\/ compile-flags: \([^#]*\).*/\1/p' $(SOURCEDIR)/$@.rs ) \
			-L "$(TMPDIR)" -Zinstrument-coverage \
			-Z unstable-options --persist-doctests=$(TMPDIR)/rustdoc-$@

	# Postprocess the profiling data so it can be used by the llvm-cov tool
	"$(LLVM_BIN_DIR)"/llvm-profdata merge --sparse \
			"$(TMPDIR)"/$@*.profraw \
			-o "$(TMPDIR)"/$@.profdata

	# Generate a coverage report using `llvm-cov show`.
	"$(LLVM_BIN_DIR)"/llvm-cov show \
			$(DEBUG_FLAG) \
			$(LLVM_COV_IGNORE_FILES) \
			--compilation-dir=. \
			--Xdemangler="$(RUST_DEMANGLER)" \
			--show-line-counts-or-regions \
			--instr-profile="$(TMPDIR)"/$@.profdata \
			$(call BIN,"$(TMPDIR)"/$@) \
			$$( \
				for file in $(TMPDIR)/rustdoc-$@/*/rust_out; do \
				[ -x "$$file" ] && printf "%s %s " -object $$file; \
				done \
			) \
		2> "$(TMPDIR)"/show_coverage_stderr.$@.txt \
		| "$(PYTHON)" $(BASEDIR)/normalize_paths.py \
		> "$(TMPDIR)"/actual_show_coverage.$@.txt || \
	( status=$$? ; \
		>&2 cat "$(TMPDIR)"/show_coverage_stderr.$@.txt ; \
		exit $$status \
	)

ifdef DEBUG_FLAG
	# The first line (beginning with "Args:" contains hard-coded, build-specific
	# file paths. Strip that line and keep the remaining lines with counter debug
	# data.
	tail -n +2 "$(TMPDIR)"/show_coverage_stderr.$@.txt \
		> "$(TMPDIR)"/actual_show_coverage_counters.$@.txt
endif

ifdef RUSTC_BLESS_TEST
	cp "$(TMPDIR)"/actual_show_coverage.$@.txt \
			expected_show_coverage.$@.txt
else
	# Compare the show coverage output (`--bless` refreshes `typical` files).
	#
	# FIXME(richkadel): None of the Rust test source samples have the
	# `// ignore-llvm-cov-show-diffs` anymore. This directive exists to work around a limitation
	# with `llvm-cov show`. When reporting coverage for multiple instantiations of a generic function,
	# with different type substitutions, `llvm-cov show` prints these in a non-deterministic order,
	# breaking the `diff` comparision.
	#
	# A partial workaround is implemented below, with `diff --ignore-matching-lines=RE`
	# to ignore each line prefixing each generic instantiation coverage code region.
	#
	# This workaround only works if the coverage counts are identical across all reported
	# instantiations. If there is no way to ensure this, you may need to apply the
	# `// ignore-llvm-cov-show-diffs` directive, and check for differences using the
	# `.json` files to validate that results have not changed. (Until then, the JSON
	# files are redundant, so there is no need to generate `expected_*.json` files or
	# compare actual JSON results.)

	$(DIFF) --ignore-matching-lines='^  | .*::<.*>.*:$$' --ignore-matching-lines='^  | <.*>::.*:$$' \
		expected_show_coverage.$@.txt "$(TMPDIR)"/actual_show_coverage.$@.txt || \
		( grep -q '^\/\/ ignore-llvm-cov-show-diffs' $(SOURCEDIR)/$@.rs && \
			>&2 echo 'diff failed, but suppressed with `// ignore-llvm-cov-show-diffs` in $(SOURCEDIR)/$@.rs' \
		) || \
		( >&2 echo 'diff failed, and not suppressed without `// ignore-llvm-cov-show-diffs` in $(SOURCEDIR)/$@.rs'; \
			false \
		)
endif

=== src/test/run-make-fulldeps/crate-hash-rustc-version/Makefile ===
-include ../../run-make-fulldeps/tools.mk

# Ensure that crates compiled with different rustc versions cannot
# be dynamically linked.

FLAGS := -Cprefer-dynamic -Zsymbol-mangling-version=v0
UNAME := $(shell uname)
ifeq ($(UNAME),Linux)
  EXT=".so"
  NM_CMD := nm -D
endif
ifeq ($(UNAME),Darwin)
  EXT=".dylib"
  NM_CMD := nm
endif

ifndef NM_CMD
all:
	exit 0
else
all:
	# a.rs is a dylib
	$(RUSTC) a.rs --crate-type=dylib $(FLAGS)
	# Write symbols to disk.
	$(NM_CMD) $(call DYLIB,a) > $(TMPDIR)/symbolsbefore
	# b.rs is a binary
	$(RUSTC) b.rs --extern a=$(TMPDIR)/liba$(EXT) --crate-type=bin -Crpath $(FLAGS)
	$(call RUN,b)
	# Now re-compile a.rs with another rustc version
	RUSTC_FORCE_INCR_COMP_ARTIFACT_HEADER=deadfeed $(RUSTC) a.rs --crate-type=dylib $(FLAGS)
	# After compiling with a different rustc version, write symbols to disk again.
	$(NM_CMD) $(call DYLIB,a) > $(TMPDIR)/symbolsafter
	# As a sanity check, test if the symbols changed:
	# If the symbols are identical, there's been an error.
	if diff $(TMPDIR)/symbolsbefore $(TMPDIR)/symbolsafter; then exit 1; fi
	$(call FAIL,b)
endif

=== src/test/run-make/dep-graph/Makefile ===
-include ../../run-make-fulldeps/tools.mk

# ignore-cross-compile

# Just verify that we successfully run and produce dep graphs when requested.

all:
	RUST_DEP_GRAPH=$(TMPDIR)/dep-graph \
    RUSTC_FORCE_INCREMENTAL=1 \
    $(RUSTC) \
        -Cincremental=$(TMPDIR)/incr \
        -Zquery-dep-graph -Zdump-dep-graph foo.rs
	test -f $(TMPDIR)/dep-graph.txt
	test -f $(TMPDIR)/dep-graph.dot

=== src/test/run-make/incremental-session-fail/Makefile ===
include ../../run-make-fulldeps/tools.mk

SESSION_DIR := $(TMPDIR)/session
OUTPUT_FILE := $(TMPDIR)/build-output

all:
	echo $(TMPDIR)
	# Make it so that rustc will fail to create a session directory.
	touch $(SESSION_DIR)
	# Check exit code is 1 for an error, and not 101 for ICE.
	RUSTC_FORCE_INCREMENTAL=1 \
	$(RUSTC) foo.rs --crate-type=rlib -C incremental=$(SESSION_DIR) > $(OUTPUT_FILE) 2>&1; [ $$? -eq 1 ]
	$(CGREP) "Could not create incremental compilation crate directory" < $(OUTPUT_FILE)
	# -v tests are fragile, hopefully this text won't change
	$(CGREP) -v "internal compiler error" < $(OUTPUT_FILE)

=== debian/changelog ===
rustc-mozilla (1.59.0+dfsg1-1~deb11u3) bullseye; urgency=medium

  * Set up the symlinks in a target also called by binary-arch.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Thu, 04 Aug 2022 09:40:53 +0200

rustc-mozilla (1.59.0+dfsg1-1~deb11u2) bullseye; urgency=medium

  * Include mips(el) stage0 binaries.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Wed, 03 Aug 2022 12:44:23 +0200

rustc-mozilla (1.59.0+dfsg1-1~deb11u1) bullseye; urgency=medium

  * Non-maintainer upload.
  * Backport to bullseye as rustc-mozilla.
  * Do a bootstrap build.
  * Disable wasm.
  * Disable new binary packages rustfmt, -clippy, -all.

 -- Emilio Pozuelo Monfort <pochu@debian.org>  Sun, 03 Jul 2022 11:51:30 +0200

rustc (1.59.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Wed, 11 May 2022 14:11:46 +0100

rustc (1.59.0+dfsg1-1~exp1) experimental; urgency=medium

  [ Fabian Grünbichler ]
  * New upstream release

 -- Ximin Luo <infinity0@debian.org>  Tue, 29 Mar 2022 14:32:01 +0100

rustc (1.58.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.

 -- Ximin Luo <infinity0@debian.org>  Tue, 29 Mar 2022 12:23:46 +0100

rustc (1.58.1+dfsg1-1~exp1) experimental; urgency=medium

  [ Fabian Gruenbichler ]
  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Mar 2022 11:32:29 +0000

rustc (1.57.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable. (Closes: #1005203)

 -- Ximin Luo <infinity0@debian.org>  Tue, 08 Mar 2022 10:51:18 +0000

rustc (1.57.0+dfsg1-1~exp1) experimental; urgency=medium

  [ Simon Chopin ]
  * d/p/d-bootstrap-rustflags.patch: remove the warnings bit, use the option
    "deny-warnings = false" in d/config.toml.in instead

  [ Fabian Grünbichler ]
  * Fix CVE-2022-21658 - std::fs::remove_dir_all TOCTOU symlink issue
  * New upstream release. (Closes: #1005203)

 -- Fabian Grünbichler <f.gruenbichler@proxmox.com>  Thu, 03 Feb 2022 19:14:04 +0100

rustc (1.56.0+dfsg1-2) unstable; urgency=medium

  * Update to debhelper 13.

 -- Ximin Luo <infinity0@debian.org>  Fri, 22 Oct 2021 23:29:14 +0100

rustc (1.56.0+dfsg1-1) unstable; urgency=medium

  * New upstream release.
  * Support terse and verbose DEB_BUILD_OPTIONS.
  * Support -Z gcc-ld=lld via symlinks.
  * Fix RUSTC_SYSROOT in rust-gdb and rust-lldb, thanks James McCoy.

 -- Ximin Luo <infinity0@debian.org>  Fri, 22 Oct 2021 18:54:49 +0100

rustc (1.56.0~beta.4+dfsg1-1~exp2) experimental; urgency=medium

  * Include upstream patch for x32 support. (Closes: #993855)
  * Update to LLVM 13.

 -- Ximin Luo <infinity0@debian.org>  Fri, 15 Oct 2021 10:44:35 +0100

rustc (1.56.0~beta.4+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Thu, 14 Oct 2021 22:50:58 +0100

rustc (1.55.0+dfsg1-2) unstable; urgency=medium

  * Actually work around segfault on ppc64el.
  * Fix FTBFS on armhf caused by GCC 11 changes.

 -- Ximin Luo <infinity0@debian.org>  Thu, 14 Oct 2021 00:36:15 +0100

rustc (1.55.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Bump test failures-allowed on s390x to 40.
  * Work around a segfault on ppc64el

 -- Ximin Luo <infinity0@debian.org>  Wed, 13 Oct 2021 22:06:15 +0100

rustc (1.55.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Sat, 09 Oct 2021 03:22:08 +0100

rustc (1.54.0+dfsg1-3) unstable; urgency=medium

  * Fix links to cargo-doc.

 -- Ximin Luo <infinity0@debian.org>  Sat, 09 Oct 2021 11:46:08 +0100

rustc (1.54.0+dfsg1-2) unstable; urgency=medium

  * Fix some more build & test failures.

 -- Ximin Luo <infinity0@debian.org>  Sat, 09 Oct 2021 03:12:35 +0100

rustc (1.54.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Re-enable backported patch for armhf & reset its allowed-failures.
  * Add compatibility patch for cargo 0.47.
  * Ignore more spurious test failures, and filed upstream.
  * Bump powerpc allowed-failures to 180 at the request of ports maintainers.

 -- Ximin Luo <infinity0@debian.org>  Sat, 09 Oct 2021 00:24:37 +0100

rustc (1.54.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.

 -- Ximin Luo <infinity0@debian.org>  Wed, 06 Oct 2021 10:37:55 +0100

rustc (1.53.0+dfsg1-4) unstable; urgency=medium

  * Ignore some hanging test regressions on non-release arches powerpc, ppc64.

 -- Ximin Luo <infinity0@debian.org>  Wed, 06 Oct 2021 19:24:11 +0100

rustc (1.53.0+dfsg1-3) unstable; urgency=medium

  * Disable patch that was backported incorrectly.
  * Temporarily increase armhf allowed-failures to 12.

 -- Ximin Luo <infinity0@debian.org>  Wed, 06 Oct 2021 19:01:54 +0100

rustc (1.53.0+dfsg1-2) unstable; urgency=medium

  * Fix some test failures.

 -- Ximin Luo <infinity0@debian.org>  Wed, 06 Oct 2021 10:29:03 +0100

rustc (1.53.0+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Update mips patches, disable a test as our workaround makes it invalid.
  * Temporarily ignore some tests that fail on big-endian.

 -- Ximin Luo <infinity0@debian.org>  Tue, 05 Oct 2021 23:19:31 +0100

rustc (1.53.0+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release. (Closes: #986803)
  * Honour parallel option in DEB_BUILD_OPTIONS. (Closes: #993871)

 -- Ximin Luo <infinity0@debian.org>  Sat, 02 Oct 2021 12:46:49 +0100

rustc (1.52.1+dfsg1-1) unstable; urgency=medium

  * Upload to unstable.
  * Reorganise dependencies, move optional rustc deps to rust-all.

 -- Ximin Luo <infinity0@debian.org>  Wed, 29 Sep 2021 20:05:55 +0100

rustc (1.52.1+dfsg1-1~exp3) experimental; urgency=medium

  * Update to LLVM 12.

 -- Ximin Luo <infinity0@debian.org>  Wed, 19 May 2021 17:52:44 +0100

rustc (1.52.1+dfsg1-1~exp2) experimental; urgency=medium

  * Fix rust-clippy dependency on libstd-rust-*

 -- Ximin Luo <infinity0@debian.org>  Sat, 15 May 2021 22:42:38 +0100

rustc (1.52.1+dfsg1-1~exp1) experimental; urgency=medium

  * New upstream release.



=== debian/control ===
Source: rustc-mozilla
Section: devel
Priority: optional
Maintainer: Debian Rust Maintainers <pkg-rust-maintainers@alioth-lists.debian.net>
Uploaders:
 Ximin Luo <infinity0@debian.org>,
 Sylvestre Ledru <sylvestre@debian.org>
Rules-Requires-Root: no
# :native annotations are to support cross-compiling, see README.Debian
Build-Depends:
 debhelper (>= 9),
 debhelper-compat (= 13),
 dpkg-dev (>= 1.17.14),
 python3:native,
# cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
# rustc:native (>= 1.58.0+dfsg) <!pkg.rustc.dlstage0>,
# rustc:native (<= 1.59.0++)    <!pkg.rustc.dlstage0>,
 llvm-13-dev:native,
 llvm-13-tools:native,
 gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
 gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
 libllvm13 (>= 1:13.0.0),
 cmake (>= 3.0) | cmake3,
# needed by some vendor crates
 pkg-config,
# this is sometimes needed by rustc_llvm
 zlib1g-dev:native,
 zlib1g-dev,
# used by rust-installer
 liblzma-dev:native,
# test dependencies:
 binutils (>= 2.26) <!nocheck> | binutils-2.26 <!nocheck>,
 git <!nocheck>,
 procps <!nocheck>,
# below are optional tools even for 'make check'
 gdb (>= 7.12) <!nocheck>,
# Extra build-deps needed for x.py to download stuff in pkg.rustc.dlstage0.
 curl <pkg.rustc.dlstage0>,
 ca-certificates <pkg.rustc.dlstage0>,
Build-Depends-Indep:
# wasi-libc (>= 0.0~git20210922.ad51334~~) <!nowasm>,
# wasi-libc (<= 0.0~git20210922.ad51334++) <!nowasm>,
 clang-13:native,
Build-Conflicts: gdb-minimal <!nocheck>
Standards-Version: 4.2.1
Homepage: http://www.rust-lang.org/
Vcs-Git: https://salsa.debian.org/rust-team/rust.git
Vcs-Browser: https://salsa.debian.org/rust-team/rust

Package: rustc-mozilla
Architecture: any
Multi-Arch: allowed
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-mozilla-dev (= ${binary:Version}),
 gcc, libc-dev, binutils (>= 2.26)
Recommends:
 cargo (>= 0.60.0~~), cargo (<< 0.61.0~~),
# llvm is needed for llvm-dwp for -C split-debuginfo=packed
 llvm-13,
Suggests:
# lld and clang are needed for wasm compilation
 lld-13, clang-13,
Conflicts: rustc
Provides: rustc (= ${binary:Version})
Replaces: libstd-rust-dev (<< 1.25.0+dfsg1-2~~), rustc
Breaks: libstd-rust-dev (<< 1.25.0+dfsg1-2~~)
Description: Rust systems programming language
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.

Package: libstd-rust-mozilla-1.59
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Rust standard libraries
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries, built as dylibs,
 needed to run dynamically-linked Rust programs (-C prefer-dynamic).

Package: libstd-rust-mozilla-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends},
 libstd-rust-mozilla-1.59 (= ${binary:Version}),
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains development files for the standard Rust libraries,
 needed to compile Rust programs. It may also be installed on a system
 of another host architecture, for cross-compiling to this architecture.

Package: libstd-rust-mozilla-dev-windows
Section: libdevel
Architecture: amd64 i386
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends:
 gcc-mingw-w64-x86-64-posix [amd64],
 gcc-mingw-w64-i686-posix [i386],
Conflicts: libstd-rust-dev-windows
Replaces: libstd-rust-dev-windows
Build-Profiles: <!nowindows>
Description: Rust standard libraries - development files
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the standard Rust libraries including development files,
 needed to cross-compile Rust programs to the *-pc-windows-gnu target
 corresponding to the architecture of this package.

#Package: libstd-rust-mozilla-dev-wasm32
#Section: libdevel
#Architecture: all
#Multi-Arch: foreign
#Depends: ${shlibs:Depends}, ${misc:Depends}
## Embeds wasi-libc so doesn't need to depend on it
## None of its licenses require source redistrib, so no need for Built-Using
#Recommends:
# lld-13, clang-13,
#Suggests:
## nodejs contains wasi-node for running the program
# nodejs (>= 12.16),
#Build-Profiles: <!nowasm>
#Description: Rust standard libraries - development files
# Rust is a curly-brace, block-structured expression language.  It
# visually resembles the C language family, but differs significantly
# in syntactic and semantic details.  Its design is oriented toward
# concerns of "programming in the large", that is, of creating and
# maintaining boundaries - both abstract and operational - that
# preserve large-system integrity, availability and concurrency.
# .
# It supports a mixture of imperative procedural, concurrent actor,
# object-oriented and pure functional styles.  Rust also supports
# generic programming and meta-programming, in both static and dynamic
# styles.
# .
# This package contains the standard Rust libraries including development files,
# needed to cross-compile Rust programs to the wasm32-unknown-unknown and
# wasm32-wasi targets.

Package: rust-mozilla-gdb
Architecture: all
Depends: gdb, ${misc:Depends}
Suggests: gdb-doc
Conflicts: rust-gdb
Replaces: rustc (<< 1.1.0+dfsg1-1), rust-gdb
Description: Rust debugger (gdb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking gdb on rust binaries.

Package: rust-mozilla-lldb
Architecture: all
# When updating, also update rust-lldb.links
Depends: lldb-13, ${misc:Depends}, python3-lldb-13
Conflicts: rust-lldb
Replaces: rustc (<< 1.1.0+dfsg1-1), rust-lldb
Description: Rust debugger (lldb)
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains pretty printers and a wrapper script for
 invoking lldb on rust binaries.

Package: rust-mozilla-doc
Section: doc
Architecture: all
Build-Profiles: <!nodoc>
Depends: ${misc:Depends},
 libjs-jquery, libjs-highlight.js, libjs-mathjax,
 fonts-open-sans, fonts-font-awesome
Recommends: cargo-doc
Conflicts: rust-doc
Replaces: rust-doc
Description: Rust systems programming language - Documentation
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains the Rust tutorial, language reference and
 standard library documentation.

Package: rust-mozilla-src
Architecture: all
Depends: ${misc:Depends}
Conflicts: rust-src
Replaces: rust-src
Description: Rust systems programming language - source code
 Rust is a curly-brace, block-structured expression language.  It
 visually resembles the C language family, but differs significantly
 in syntactic and semantic details.  Its design is oriented toward
 concerns of "programming in the large", that is, of creating and
 maintaining boundaries - both abstract and operational - that
 preserve large-system integrity, availability and concurrency.
 .
 It supports a mixture of imperative procedural, concurrent actor,
 object-oriented and pure functional styles.  Rust also supports
 generic programming and meta-programming, in both static and dynamic
 styles.
 .
 This package contains sources of the Rust compiler and standard
 libraries, useful for IDEs and code analysis tools such as Racer.

#Package: rust-mozilla-clippy
#Architecture: any
#Multi-Arch: allowed
#Depends: ${misc:Depends}, ${shlibs:Depends},
# libstd-rust-mozilla-1.59 (= ${binary:Version})
#Recommends: cargo
#Description: Rust linter
# Rust is a curly-brace, block-structured expression language.  It
# visually resembles the C language family, but differs significantly
# in syntactic and semantic details.  Its design is oriented toward
# concerns of "programming in the large", that is, of creating and
# maintaining boundaries - both abstract and operational - that
# preserve large-system integrity, availability and concurrency.
# .
# It supports a mixture of imperative procedural, concurrent actor,
# object-oriented and pure functional styles.  Rust also supports
# generic programming and meta-programming, in both static and dynamic

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/vendor.mk
include /usr/share/dpkg/architecture.mk
SED_VERSION_SHORT := sed -re 's/([^.]+)\.([^.]+)\..*/\1.\2/'
RUST_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | $(SED_VERSION_SHORT))
RUST_LONG_VERSION := $(shell echo '$(DEB_VERSION_UPSTREAM)' | sed -re 's/([^+]+).*/\1/')
LIBSTD_PKG := libstd-rust-mozilla-$(RUST_VERSION)
# Sed expression that matches the "rustc-mozilla" we have in our Build-Depends field
SED_RUSTC_BUILDDEP := sed -ne "/^Build-Depends:/,/^[^[:space:]\#]/{/^ *rustc-mozilla:native .*,/p}" debian/control
# Version of /usr/bin/rustc
LOCAL_RUST_VERSION := $(shell rustc --version --verbose | sed -ne 's/^release: //p')

include /usr/share/dpkg/buildflags.mk
export CFLAGS CXXFLAGS CPPFLAGS LDFLAGS
export CARGO_HOME = $(CURDIR)/debian/cargo

# Defines DEB_*_RUST_TYPE triples
include debian/architecture.mk
# for dh_install substitution variable
export DEB_HOST_RUST_TYPE

# for dh_install substitution variable
export RUST_LONG_VERSION

DEB_DESTDIR := $(CURDIR)/debian/tmp

# Use system LLVM (comment out to use vendored LLVM)
LLVM_VERSION = 13
OLD_LLVM_VERSION = 12
# Make it easier to test against a custom LLVM
ifneq (,$(LLVM_DESTDIR))
LLVM_LIBRARY_PATH := $(LLVM_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(LLVM_DESTDIR)/usr/lib
LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(LLVM_LIBRARY_PATH),$(LLVM_LIBRARY_PATH))
export LD_LIBRARY_PATH
endif

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
NJOBS := -j $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif
RUSTBUILD = RUST_BACKTRACE=1 python3 src/bootstrap/bootstrap.py $(NJOBS)
RUSTBUILD_FLAGS = --stage 2 --config debian/config.toml --on-fail env
# rust-tidy depends on lots of modules that we strip out of the build.
# it also tries to access the network for some reason. so just disable it.
RUSTBUILD_TEST = $(RUSTBUILD) test --no-fail-fast --exclude src/tools/tidy
# To run a specific test, run something like:
#   $ debian/rules override_dh_auto_test-arch \
#     RUSTBUILD_TEST_FLAGS="src/test/run-make --test-args extern-fn-struct"
# See src/bootstrap/README.md for more options.
RUSTBUILD_TEST_FLAGS =

# https://github.com/rust-lang/rust/issues/89744
# TODO: remove when we update cargo to 1.55 / 0.56
# upstream bug still exists and is under investigation, but is hidden by newer cargo
export CARGO_PROFILE_RELEASE_BUILD_OVERRIDE_OPT_LEVEL=0

update-version:
	oldver=$(shell $(SED_RUSTC_BUILDDEP) | sed -ne 's/.*(<= \(.*\)).*/\1/gp' | $(SED_VERSION_SHORT)); \
	newver=$(RUST_VERSION); \
	debian/update-version.sh $$oldver $$newver $(RUST_LONG_VERSION) $(CARGO_NEW)

# Below we detect how we're supposed to bootstrap the stage0 compiler. See
# README.Debian for more details of the cases described below.
#
PRECONFIGURE_CHECK = :
HAVE_BINARY_TARBALL := $(shell ls -1 stage0*/*/*$(DEB_HOST_RUST_TYPE)* 2>/dev/null | wc -l)
DOWNLOAD_BOOTSTRAP := false
# allow not using the binary tarball although it exists
#ifneq (,$(filter $(DEB_HOST_ARCH), amd64 arm64 armhf i386 powerpc ppc64el s390x))
#  HAVE_BINARY_TARBALL := 0
#endif
ifeq (0,$(HAVE_BINARY_TARBALL))
    # Case A (Building from source): the extracted source tree does not include
    # a bootstrapping tarball for the current architecture e.g. because the
    # distro already has a rustc for this arch, or the uploader expects that
    # this requirement be fulfilled in some other way.
    #
    # Case A-1: the builder did not select the "pkg.rustc.dlstage0" build profile.
    # In this case, we use the distro's rustc - either the previous or current version.
    ifeq (,$(findstring pkg.rustc.dlstage0,$(DEB_BUILD_PROFILES)))
        # Make it easier to test against a custom rustc
        ifneq (,$(RUST_DESTDIR))
        RUST_LIBRARY_PATH := $(RUST_DESTDIR)/usr/lib/$(DEB_HOST_MULTIARCH):$(RUST_DESTDIR)/usr/lib
        LD_LIBRARY_PATH := $(if $(LD_LIBRARY_PATH),$(LD_LIBRARY_PATH):$(RUST_LIBRARY_PATH),$(RUST_LIBRARY_PATH))
        export LD_LIBRARY_PATH
        endif
    #
    # Case A-2: the builder selected the "dlstage0" build profile.
    # In this case, the rust build scripts will download a stage0 into stage0/ and use that.
    # We don't need to do anything specific in this build file, so this case is empty.
    else
        DOWNLOAD_BOOTSTRAP := true
    endif
else
    # Case B (Bootstrapping a new distro): the extracted source tree does
    # include a bootstrapping tarball for the current architecture; see the
    # `source_orig-stage0` target below on how to build this.
    #
    # In this case, we'll bootstrap from the stage0 given in that tarball.
    # To ensure the uploader of the .dsc didn't make a mistake, we first check
    # that rustc isn't a Build-Depends for the current architecture.
    ifneq (,$(shell $(SED_RUSTC_BUILDDEP)))
    ifeq (,$(shell $(SED_RUSTC_BUILDDEP) | grep '!$(DEB_HOST_ARCH)'))
        PRECONFIGURE_CHECK = $(error found matches for stage0/*/*$(DEB_HOST_RUST_TYPE)*, \
          but rustc might be a Build-Depends for $(DEB_HOST_ARCH))
    endif
    endif
endif

BUILD_DOCS := true
ifneq (,$(findstring nodoc,$(DEB_BUILD_PROFILES)))
  BUILD_DOCS := false
endif
ifneq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
  BUILD_DOCS := false
endif

BUILD_WASM := false
ifneq (,$(findstring nowasm,$(DEB_BUILD_PROFILES)))
  BUILD_WASM := false
endif

WINDOWS_SUPPORT := amd64 i386
BUILD_WINDOWS := true
ifneq (,$(findstring nowindows,$(DEB_BUILD_PROFILES)))
  BUILD_WINDOWS := false
endif
ifeq (,$(filter $(DEB_HOST_ARCH), $(WINDOWS_SUPPORT)))
  BUILD_WINDOWS := false
else
  ifeq (,$(filter $(DEB_BUILD_ARCH), $(WINDOWS_SUPPORT)))
    ifeq (true,$(BUILD_WINDOWS))
      $(error cannot cross-compile from $(DEB_BUILD_ARCH) to $(DEB_HOST_ARCH), unless "nowindows" is in DEB_BUILD_PROFILES)
    endif
  endif
  ifeq (i386,$(DEB_HOST_ARCH))
    WINDOWS_ARCH := i686
  else
    WINDOWS_ARCH := x86_64
  endif
endif
# for dh_install substitution variable
export WINDOWS_ARCH

MAKE_OPTIMISATIONS := true
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
  MAKE_OPTIMISATIONS := false
endif

VERBOSITY_SUB := $(words $(filter terse,$(DEB_BUILD_OPTIONS)))
VERBOSITY_ADD := $(words $(filter verbose,$(DEB_BUILD_OPTIONS)))
VERBOSITY := $(shell expr 2 + $(VERBOSITY_ADD) - $(VERBOSITY_SUB))

ifeq ($(shell test $(VERBOSITY) -ge 3; echo $$?),0)
  export DH_VERBOSE=1
endif

ifeq ($(shell test $(VERBOSITY) -le 0; echo $$?),0)
  export DH_QUIET=1
.SILENT:
endif

# Build products or non-source files in src/, that shouldn't go in rust-mozilla-src
SRC_CLEAN = src/bootstrap/bootstrap.pyc \
	src/etc/__pycache__/

# Try to work around #933045
ifneq (,$(filter $(DEB_BUILD_ARCH), mips mipsel))
  SYSTEM_WORKAROUNDS += export MALLOC_ARENA_MAX=1;
endif

%:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

.PHONY: .dbg-windows
.dbg-windows:
	@echo host=$(DEB_BUILD_ARCH) target=$(DEB_HOST_ARCH) BUILD_WINDOWS=$(BUILD_WINDOWS) WINDOWS_ARCH=$(WINDOWS_ARCH)

.PHONY: build
build:
	$(SYSTEM_WORKAROUNDS) dh $@ --parallel

override_dh_clean:
	# Upstream contains a lot of these
	dh_clean -XCargo.toml.orig
	rm -f stage0/*/*-mips-* stage0/*/*-mipsel-*

debian/config.toml: debian/config.toml.in debian/rules
	u="$(DEB_VERSION_UPSTREAM)"; \
	if [ "$$u" != "$${u%~beta.*+dfsg*}" ]; then channel="beta"; \
	else channel="stable"; fi; \
	m4  -DRELEASE_CHANNEL="$$channel" \
		-DDEB_BUILD_RUST_TYPE="$(DEB_BUILD_RUST_TYPE)" \
		-DDEB_HOST_RUST_TYPE="$(DEB_HOST_RUST_TYPE)" \
		-DDEB_TARGET_RUST_TYPE="$(DEB_TARGET_RUST_TYPE)" \
		-DDEB_BUILD_GNU_TYPE="$(DEB_BUILD_GNU_TYPE)" \
		-DDEB_HOST_GNU_TYPE="$(DEB_HOST_GNU_TYPE)" \
		-DDEB_TARGET_GNU_TYPE="$(DEB_TARGET_GNU_TYPE)" \
		-DMAKE_OPTIMISATIONS="$(MAKE_OPTIMISATIONS)" \
		-DVERBOSITY="$(VERBOSITY)" \
		-DLLVM_DESTDIR="$(LLVM_DESTDIR)" \
		-DLLVM_VERSION="$(LLVM_VERSION)" \
		-DRUST_DESTDIR="$(RUST_DESTDIR)" \
		"$<" > "$@"
	if $(DOWNLOAD_BOOTSTRAP) || [ $(HAVE_BINARY_TARBALL) != 0 ]; \

## rustc-mozilla 1.63.0%2Bdfsg1

=== debian/control ===
--- 
+++ 
@@ -9,16 +9,16 @@
 # :native annotations are to support cross-compiling, see README.Debian
 Build-Depends:
  debhelper (>= 9),
- debhelper-compat (= 13),
+ debhelper-compat (= 12),
  dpkg-dev (>= 1.17.14),
  python3:native,
-# cargo:native (>= 0.40.0)      <!pkg.rustc.dlstage0>,
-# rustc:native (>= 1.58.0+dfsg) <!pkg.rustc.dlstage0>,
-# rustc:native (<= 1.59.0++)    <!pkg.rustc.dlstage0>,
+# cargo:native (>= 0.60.0)      <!pkg.rustc.dlstage0>,
+# rustc:native (>= 1.62.0+dfsg) <!pkg.rustc.dlstage0>,
+# rustc:native (<= 1.63.0++)    <!pkg.rustc.dlstage0>,
  llvm-13-dev:native,
  llvm-13-tools:native,
- gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
- gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
+# gcc-mingw-w64-x86-64-posix:native [amd64] <!nowindows>,
+# gcc-mingw-w64-i686-posix:native [i386] <!nowindows>,
  libllvm13 (>= 1:13.0.0),
  cmake (>= 3.0) | cmake3,
 # needed by some vendor crates
@@ -38,8 +38,8 @@
  curl <pkg.rustc.dlstage0>,
  ca-certificates <pkg.rustc.dlstage0>,
 Build-Depends-Indep:
-# wasi-libc (>= 0.0~git20210922.ad51334~~) <!nowasm>,
-# wasi-libc (<= 0.0~git20210922.ad51334++) <!nowasm>,
+# wasi-libc (>= 0.0~git20220510.9886d3d~~) <!nowasm>,
+# wasi-libc (<= 0.0~git20220510.9886d3d++) <!nowasm>,
  clang-13:native,
 Build-Conflicts: gdb-minimal <!nocheck>
 Standards-Version: 4.2.1
@@ -55,7 +55,7 @@
  libstd-rust-mozilla-dev (= ${binary:Version}),
  gcc, libc-dev, binutils (>= 2.26)
 Recommends:
- cargo (>= 0.60.0~~), cargo (<< 0.61.0~~),
+ cargo (>= 0.64.0~~), cargo (<< 0.65.0~~),
 # llvm is needed for llvm-dwp for -C split-debuginfo=packed
  llvm-13,
 Suggests:
@@ -78,7 +78,7 @@
  generic programming and meta-programming, in both static and dynamic
  styles.
 
-Package: libstd-rust-mozilla-1.59
+Package: libstd-rust-mozilla-1.63
 Section: libs
 Architecture: any
 Multi-Arch: same
@@ -105,7 +105,7 @@
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends},
- libstd-rust-mozilla-1.59 (= ${binary:Version}),
+ libstd-rust-mozilla-1.63 (= ${binary:Version}),
 Description: Rust standard libraries - development files
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -123,33 +123,32 @@
  needed to compile Rust programs. It may also be installed on a system
  of another host architecture, for cross-compiling to this architecture.
 
-Package: libstd-rust-mozilla-dev-windows
-Section: libdevel
-Architecture: amd64 i386
-Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Recommends:
- gcc-mingw-w64-x86-64-posix [amd64],
- gcc-mingw-w64-i686-posix [i386],
-Conflicts: libstd-rust-dev-windows
-Replaces: libstd-rust-dev-windows
-Build-Profiles: <!nowindows>
-Description: Rust standard libraries - development files
- Rust is a curly-brace, block-structured expression language.  It
- visually resembles the C language family, but differs significantly
- in syntactic and semantic details.  Its design is oriented toward
- concerns of "programming in the large", that is, of creating and
- maintaining boundaries - both abstract and operational - that
- preserve large-system integrity, availability and concurrency.
- .
- It supports a mixture of imperative procedural, concurrent actor,
- object-oriented and pure functional styles.  Rust also supports
- generic programming and meta-programming, in both static and dynamic
- styles.
- .
- This package contains the standard Rust libraries including development files,
- needed to cross-compile Rust programs to the *-pc-windows-gnu target
- corresponding to the architecture of this package.
+#Package: libstd-rust-mozilla-dev-windows
+#Section: libdevel
+#Architecture: amd64 i386
+#Multi-Arch: same
+#Depends: ${shlibs:Depends}, ${misc:Depends}
+#Recommends:
+# gcc-mingw-w64-x86-64-posix [amd64],
+# gcc-mingw-w64-i686-posix [i386],
+#Conflicts: libstd-rust-dev-windows
+#Build-Profiles: <!nowindows>
+#Description: Rust standard libraries - development files
+# Rust is a curly-brace, block-structured expression language.  It
+# visually resembles the C language family, but differs significantly
+# in syntactic and semantic details.  Its design is oriented toward
+# concerns of "programming in the large", that is, of creating and
+# maintaining boundaries - both abstract and operational - that
+# preserve large-system integrity, availability and concurrency.
+# .
+# It supports a mixture of imperative procedural, concurrent actor,
+# object-oriented and pure functional styles.  Rust also supports
+# generic programming and meta-programming, in both static and dynamic
+# styles.
+# .
+# This package contains the standard Rust libraries including development files,
+# needed to cross-compile Rust programs to the *-pc-windows-gnu target
+# corresponding to the architecture of this package.
 
 #Package: libstd-rust-mozilla-dev-wasm32
 #Section: libdevel
@@ -185,8 +184,8 @@
 Architecture: all
 Depends: gdb, ${misc:Depends}
 Suggests: gdb-doc
+Replaces: rustc (<< 1.1.0+dfsg1-1)
 Conflicts: rust-gdb
-Replaces: rustc (<< 1.1.0+dfsg1-1), rust-gdb
 Description: Rust debugger (gdb)
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -207,8 +206,8 @@
 Architecture: all
 # When updating, also update rust-lldb.links
 Depends: lldb-13, ${misc:Depends}, python3-lldb-13
+Replaces: rustc (<< 1.1.0+dfsg1-1)
 Conflicts: rust-lldb
-Replaces: rustc (<< 1.1.0+dfsg1-1), rust-lldb
 Description: Rust debugger (lldb)
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -234,7 +233,6 @@
  fonts-open-sans, fonts-font-awesome
 Recommends: cargo-doc
 Conflicts: rust-doc
-Replaces: rust-doc
 Description: Rust systems programming language - Documentation
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -255,7 +253,6 @@
 Architecture: all
 Depends: ${misc:Depends}
 Conflicts: rust-src
-Replaces: rust-src
 Description: Rust systems programming language - source code
  Rust is a curly-brace, block-structured expression language.  It
  visually resembles the C language family, but differs significantly
@@ -276,7 +273,7 @@
 #Architecture: any
 #Multi-Arch: allowed
 #Depends: ${misc:Depends}, ${shlibs:Depends},
-# libstd-rust-mozilla-1.59 (= ${binary:Version})
+# libstd-rust-mozilla-1.63 (= ${binary:Version})
 #Recommends: cargo
 #Description: Rust linter
 # Rust is a curly-brace, block-structured expression language.  It
@@ -289,3 +286,5 @@
 # It supports a mixture of imperative procedural, concurrent actor,
 # object-oriented and pure functional styles.  Rust also supports
 # generic programming and meta-programming, in both static and dynamic
+# styles.
+# .
